export function map (array, callback) {
    let arr = []
    for(let index = 0 ; index < array.length ; index++){
        let result = callback(array[index],index)
        arr.push(result)         
    }
    return arr
}

export function reduce (array, callback , initValue){
    let total = initValue ? initValue : array[0]
    for(let index = 0 ; index < array.length ; index++){
        total = callback(total,array[index],index)
    }

    return total
}

export function filter (array, callback) {
    const arr = []
    for(let index = 0 ; index < array.length ; index++){
        let result = callback(array[index],index)
        result && arr.push(array[index])
    }
    return arr
}

export function find (array, callback) {
    for(let index = 0 ; index < array.length ; index++){
        if(callback(array[index],index)){
            return array[index]
        }
    }
    return undefined
}

export function findIndex (array, callback) {
    for(let index = 0 ; index < array.length ; index++){
        if(callback(array[index],index)){
            return index
        }
    }
    return -1
}

export function every (array, callback) {
    for(let index = 0 ; index < array.length ; index++){
        if(!callback(array[index],index)){
            return false
        }
    }
    return true
}

export function some (array, callback) {
    for(let index = 0 ; index < array.length ; index++){
        if(callback(array[index],index)){
            return true
        }
    }
    return false
}