export function throttle (callback , delay) {
    let pre = 0                     // 初次编译时执行
    return function (event) {       // 节流函数/真正的事件回调函数     this为发生事件的标签
        const current = Date.now()
        if( current - pre > delay) {
            // 调用真正处理事件的函数,this是事件源,参数是event
            callback.call(this,event)
            pre = current
        }
       
    }
}